## Public API Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- File List
- File Members

# csutil/array.h File Reference

Generic Array Template. More...

`#include "comparator.h"`
`#include <new>`

Go to the source code of this file.

## Classes

class | csArray< T, ElementHandler, MemoryAllocator >
| A templated array class. More...
class | csArray< T, ElementHandler, MemoryAllocator >::Iterator
| Iterator for the Array<> class. More...
class | csArrayCmp< T, K >
| A functor template which encapsulates a key and a comparison function for use with key-related csArray<> searching methods, such as FindKey() and FindSortedKey(). More...
class | csArrayElementHandler< T >
| The default element handler for csArray. More...
class | csArrayMemoryAllocator< T >
| The default allocator for csArray. More...
class | csSafeCopyArray< T >
| Convenience class to make a version of csArray<> that does a safe-copy in case of reallocation of the array. More...
class | csSafeCopyArrayMemoryAllocator< T, ElementHandler >
| Special allocator for csArray that makes sure that when the array is reallocated that the objects are properly constructed and destructed at their new position. More...

## Defines

#define | csArrayCmpDecl(T1, T2) csArrayCmp<T1,T2>
#define | csArrayCmpInvoke(C, R) C(R)
#define | csArrayTemplate(K) template <class K>

## Variables

const size_t | csArrayItemNotFound = (size_t)-1
| This value is returned whenever an array item could not be located or does not exist.

## Detailed Description

Generic Array Template.

Definition in file array.h.